#!/usr/bin/env python
#Author: Mark Feineigle
#Create Date: 2018/02/02
#Last Modify: 2018/02/02
#Euclid's algorithms to find greatest common divisor
# (2017)_Stallings_-_Cryptography_and_network_security_principles_and_practice.pdf
# page 60

#import numpy as np
import math

# solves ax + by = d = gcd(a, b)
def extendedEuclid(a, b, x2=1, x1=0, y2=0, y1=1, debug=False):
  #q = np.floor(a/b)
  #r = np.mod(a, b)
  q = math.floor(a/b)
  r = a % b
  x = x2 - q*x1
  y = y2 - q*y1
  if debug:
    print b, r, q, x, y
  if r > 0:
    return extendedEuclid(b, r, x1, x, y1, y, debug)
  else:
    return b, x1, y1 #(d,x,y)

def polyGCD(a, b, v, w):
  r = a % b


if __name__ == "__main__":
  #print extendedEuclid(1759, 550, debug=True)
  #print extendedEuclid(1160718174, 316258250)
  #print extendedEuclid(0x02, 2**8)
  #print extendedEuclid(7, 160, debug=True)
  #print extendedEuclid(11, 10800, debug=True)
  print extendedEuclid(283, 131, debug=True)
